---
title: ExtendableEvent.waitUntil()
slug: Web/API/ExtendableEvent/waitUntil
tags:
  - API
  - ExtendableEvent
  - Method
  - Reference
  - waitUntil
---
<div>{{APIRef("Service Workers API")}}</div>

<p><span class="seoSummary">The <code><strong>ExtendableEvent.waitUntil()</strong></code> method tells the event dispatcher that work is ongoing. It can also be used to detect whether that work was successful. In service workers, <code>waitUntil()</code> tells the browser that work is ongoing until the promise settles, and it shouldn't terminate the service worker if it wants that work to complete.</span></p>

<p>The {{domxref("ServiceWorkerGlobalScope/install_event", "install")}} events in <a href="/en-US/docs/Web/API/ServiceWorkerGlobalScope">service workers</a> use <code>waitUntil()</code> to hold the service worker in the {{domxref("ServiceWorkerRegistration.installing", "installing")}} phase until tasks complete. If the promise passed to <code>waitUntil()</code> rejects, the install is considered a failure, and the installing service worker is discarded. This is primarily used to ensure that a service worker is not considered installed until all of the core caches it depends on are successfully populated.</p>

<p>The {{domxref("ServiceWorkerGlobalScope/activate_event", "activate")}} events in <a href="/en-US/docs/Web/API/ServiceWorkerGlobalScope">service workers</a> use <code>waitUntil()</code> to buffer functional events such as <code>fetch</code> and <code>push</code> until the promise passed to <code>waitUntil()</code> settles. This gives the service worker time to update database schemas and delete outdated {{domxref("Cache", "caches")}}, so other events can rely on a completely upgraded state.</p>

<p>The <code>waitUntil()</code> method must be initially called within the event callback, but after that it can be called multiple times, until all the promises passed to it settle.</p>

<div class="note">
<p><strong>Note</strong>: The behaviour described in the above paragraph was fixed in Firefox 43 (see {{bug(1180274)}}).</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>extendableEvent</em>.waitUntil(<em>promise</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<p>A {{jsxref("Promise")}}.</p>

<h2 id="Example">Example</h2>

<p>Using <code>waitUntil()</code> within a service worker's <code>install</code> event:</p>

<pre class="brush: js;highlight:[10] notranslate">addEventListener('install', event =&gt; {
  const preCache = async () =&gt; {
    const cache = await caches.open('static-v1');
    return cache.addAll([
      '/',
      '/about/',
      '/static/styles.css'
    ]);
  };
  event.waitUntil(preCache());
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-extendableevent-waituntil', 'waitUntil()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ExtendableEvent.waitUntil")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise")}}</li>
</ul>
